# Project Maat
## Description

Project Maat is the codename of my C++ course "mini-project" based on the quote "Entre le fort et le faible, entre le riche et le pauvre, entre le maître et le serviteur, c’est la liberté qui opprime et la loi qui affranchit." - [Henri Lacordaire](https://en.wikipedia.org/wiki/Jean-Baptiste_Henri_Lacordaire).

This game is aimed to be a puzzle game in which the player sets different laws for the world and the people within it as to control what happens after hitting "play" and achieve the level's goal. I was inspired both by [The Incredible Machine](https://en.wikipedia.org/wiki/The_Incredible_Machine_(video_game)) and its successors and by a much more recent game : [Baba is you](https://en.wikipedia.org/wiki/Baba_Is_You).

## Structure

![UML Diagram](UML_Class_Diagram.png)

## TODO

 - [ ] Level
  - [x] Structure
  - [x] Parsing from XML
  - [ ] A*
 - [ ] Entities
  - [x] Structure
  - [x] Parsing from XML
  - [ ] Moving
  - [ ] Decorators (Rules)
 - [ ] Rules
  - [ ] Creation
  - [ ] Interaction with entities
  - [ ] Parsing of rules and creation of subsequent decorators
 - [ ] Graphics
  - [x] Scene rendering
  - [ ] UI
  - [ ] Menu ?
 - [ ] Gameloop
  - [ ] Transition from starting to running state and vice-versa
  - [ ] Entity behaviour evolution
  - [ ] Rule application
  - [ ] Saving state through serialization ?
 - [ ] UML