//
// Created by trotfunky on 06/06/19.
//

#ifndef SRC_ENTITY_H
#define SRC_ENTITY_H

#include <SFML/Graphics.hpp>
#include <pugixml.hpp>

#include "Utils.h"


enum class EntityType
{
    Citizen,
    Significant,
    House,
    Car,
};

enum class State
{
    Moving,
    Fleeing,
    Waiting,
    Idle,
};

enum class Orientation
{
    Nort,
    East,
    South,
    West,
};


class Entity
{
public:
    /// x,y, width and height are in grid coordinates
    Entity(int x, int y, EntityType type, sf::Texture* texture, int width = 1, int height = 1);
    explicit Entity(const pugi::xml_node& entityNode, sf::Texture* texture);

    void move();
    void update();

    const sf::RectangleShape& getShape() const;

    /// Position of the target of the current action on the map
    sf::Vector2i target;
private:
    static const std::map<std::string,EntityType> entityTypeLookup;

    EntityType type;

    // As it contains position, size and orientation, we do not need anything more
    sf::RectangleShape shape;

    State currentState;
    /// Used with rules : last to update has priority
    State nextState;

    /// Used with rules : last to update has priority
    sf::Vector2i nextTarget;
};


#endif //SRC_ENTITY_H
